#ifndef __BF_H_
#define __BF_H_

#define BF_DEBUG 1

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <errno.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "datadefs.h"

class Brainfuck
{
    public:
	Brainfuck(const char*);
	void run();
	
    private:
	static u8 *data, *code;
	static u8 *filebuf;

	static int codesize, filesize;
	static int P, IP, LP, FP, oldFP;
	static int loopstack[256][2];
	static FILE *file;
	static int sockfd, acceptfd;

	typedef void (*fptr)();
	static fptr opcodes[256];
	
	inline void exec();

	static void Error(const char*);
	static void Dump(int);

	static void NUL();
	static void INC();
	static void DEC();
	static void LEFT();
	static void RIGHT();
	static void DO();
	static void LOOP();
	static void OUT();
	static void IN();

	static void FOPEN();
	static void FREAD();
	static void FWRITE();
	static void FBACK();
	static void FFORTH();

	static void FileCheckBuf();

	static void CONNECT();
	static void LISTEN();
	static void ACCEPT();
	static void SEND();
	static void RECV();
};

#endif//__BF_H_

